//
//  HoldTimeGapButton.m
//  HoldTimeGapButton
//
//  Created by apple on 2017/8/4.
//  Copyright © 2017年 cheniue. All rights reserved.
//

#import "HoldTimeGapButton.h"

@interface HoldTimeGapButton ()

@property(nonatomic,assign)long long clickTimeCount;
@property(nonatomic,assign)int currentClickInsert;

@end

@implementation HoldTimeGapButton

-(instancetype)initWithFrame:(CGRect)frame
{
    self = [super initWithFrame:frame];
    if (self)
    {
        self.eachTimeGap = 0.2f;
        self.autoStartTimeGap = 0.2f;
        self.currentNumberCount = 0;
        self.currentClickInsert = 0;
        self.clickTimeCount = 0;
        self.currentNumberCountCleanWhileTouchDown = NO;
        [self addTarget:self action:@selector(autoInsertFunctionStart) forControlEvents:UIControlEventTouchDown];
    }
    return self;
}

-(void)autoInsertFunctionRemove
{
    [self removeTarget:self action:@selector(autoInsertFunctionNormalUpInside) forControlEvents:UIControlEventTouchUpInside];
    [self removeTarget:self action:@selector(autoInsertFunctionUnusualCancel) forControlEvents:UIControlEventTouchCancel|UIControlEventTouchUpOutside|UIControlEventTouchDragOutside];
    [NSObject cancelPreviousPerformRequestsWithTarget:self selector:@selector(autoInsertNumberFunction:) object:@(self.clickTimeCount)];
}

-(void)autoInsertNumberFunction:(NSNumber*)indexNumber
{
    long long clickIndex = [indexNumber longLongValue];
    if (clickIndex == self.clickTimeCount)
    {
        self.currentClickInsert++;
        
        if (self.numberInsertEventBlock)
        {
            typeof(self) __weak weakself = self;
            typeof(weakself) __strong strongself = weakself;
            self.numberInsertEventBlock(strongself, strongself.currentNumberCount+strongself.currentClickInsert);
        }
        
        [self performSelector:@selector(autoInsertNumberFunction:) withObject:@(clickIndex) afterDelay:self.eachTimeGap];
    }
}

-(void)autoInsertFunctionStart
{
    [self autoInsertFunctionRemove];
    self.currentClickInsert = 0;
    self.clickTimeCount ++;
    if (self.currentNumberCountCleanWhileTouchDown)
    {
        self.currentNumberCount = 0;
    }
    if (self.numberBeginEventBlock)
    {
        typeof(self) __weak weakself = self;
        typeof(weakself) __strong strongself = weakself;
        self.numberBeginEventBlock(strongself);
    }
    [self addTarget:self action:@selector(autoInsertFunctionNormalUpInside) forControlEvents:UIControlEventTouchUpInside];
    [self addTarget:self action:@selector(autoInsertFunctionUnusualCancel) forControlEvents:UIControlEventTouchCancel|UIControlEventTouchUpOutside|UIControlEventTouchDragOutside];
    [self performSelector:@selector(autoInsertNumberFunction:) withObject:@(self.clickTimeCount) afterDelay:self.autoStartTimeGap];
}

-(void)autoInsertFunctionNormalUpInside
{
    if (self.currentClickInsert == 0)
    {
        self.currentClickInsert = 1;
        if (self.numberInsertEventBlock)
        {
            typeof(self) __weak weakself = self;
            typeof(weakself) __strong strongself = weakself;
            self.numberInsertEventBlock(strongself, strongself.currentNumberCount+strongself.currentClickInsert);
        }
    }
    else
    {
        
    }
    self.currentNumberCount += self.currentClickInsert;
    [self autoInsertFunctionRemove];
    
    if (self.numberFinshEventBlock)
    {
        typeof(self) __weak weakself = self;
        typeof(weakself) __strong strongself = weakself;
        self.numberFinshEventBlock(strongself);
    }
}

-(void)autoInsertFunctionUnusualCancel
{
    self.currentNumberCount += self.currentClickInsert;
    [self autoInsertFunctionRemove];
    if (self.numberFinshEventBlock)
    {
        typeof(self) __weak weakself = self;
        typeof(weakself) __strong strongself = weakself;
        self.numberFinshEventBlock(strongself);
    }
}

-(void)dealloc
{
    [self removeTarget:self action:@selector(autoInsertFunctionStart) forControlEvents:UIControlEventTouchDown];
    [self autoInsertFunctionRemove];
    printf("长按自动增加的控件已经被销毁");
}

@end
